Index: /code/branches/gui/CMakeLists.txt
===================================================================
--- /code/branches/gui/CMakeLists.txt	(revision 1644)
+++ /code/branches/gui/CMakeLists.txt	(revision 1645)
@@ -54,7 +54,7 @@
 
 #use 'cmake -D make_verb:1 path' to get verbose make output when compiling
-IF (MAKE_VERB)
+#IF (MAKE_VERB)
  SET(CMAKE_VERBOSE_MAKEFILE TRUE)
-ENDIF (MAKE_VERB)
+#ENDIF (MAKE_VERB)
 
 
Index: /code/branches/gui/cmake/FindCEGUI.cmake
===================================================================
--- /code/branches/gui/cmake/FindCEGUI.cmake	(revision 1644)
+++ /code/branches/gui/cmake/FindCEGUI.cmake	(revision 1645)
@@ -39,4 +39,5 @@
 SET(CEGUI_INCLUDE_DIR ${CEGUI_INCLUDE_DIR} CACHE PATH "")
 SET(CEGUI_LIBRARIES ${CEGUI_LIBRARIES} CACHE STRING "")
+SET(CEGUI_SCRIPT_LIBRARIES "CEGUILuaScriptModule" CACHE STRING "")
 SET(CEGUI_LIB_DIR ${CEGUI_LIB_DIR} CACHE PATH "")
 
Index: /code/branches/gui/src/core/CMakeLists.txt
===================================================================
--- /code/branches/gui/src/core/CMakeLists.txt	(revision 1644)
+++ /code/branches/gui/src/core/CMakeLists.txt	(revision 1645)
@@ -57,5 +57,5 @@
 ADD_CUSTOM_COMMAND(
   OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/tolua/tolua_bind.cc
-  COMMAND ${TOLUA_EXE} -n core -o ../../src/core/tolua/tolua_bind.cc -H ../../src/core/tolua/tolua_bind.h ../../src/core/tolua/tolua.pkg
+  COMMAND ${TOLUA_EXE} -n Core -o ../../src/core/tolua/tolua_bind.cc -H ../../src/core/tolua/tolua_bind.h ../../src/core/tolua/tolua.pkg
   DEPENDS tolua
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/bin/lib
Index: /code/branches/gui/src/core/Exception.h
===================================================================
--- /code/branches/gui/src/core/Exception.h	(revision 1644)
+++ /code/branches/gui/src/core/Exception.h	(revision 1645)
@@ -100,5 +100,5 @@
         }
 
-        ~SpecificException() { }
+        ~SpecificException() throw() { }
 
         ExceptionType getType() const { return Type; }
@@ -133,6 +133,6 @@
 #ifndef NDEBUG
 #define OrxAssert(condition, errorMessage) \
-    condition ? ((void)0) : (orxonox::OutputHandler::getOutStream().setOutputLevel(ORX_ERROR) << errorMessage << std::endl); \
-    assert(condition);
+    condition ? ((void)0) : (void)(orxonox::OutputHandler::getOutStream().setOutputLevel(ORX_ERROR) << errorMessage << std::endl); \
+    assert(condition)
 #else
 #define OrxAssert(condition, errorMessage)  ((void)0)
Index: /code/branches/gui/src/core/input/InputManager.cc
===================================================================
--- /code/branches/gui/src/core/input/InputManager.cc	(revision 1644)
+++ /code/branches/gui/src/core/input/InputManager.cc	(revision 1645)
@@ -86,6 +86,6 @@
         , stateCalibrator_(0)
         , stateEmpty_(0)
+        , bCalibrating_(false)
         , keyboardModifiers_(0)
-        , bCalibrating_(false)
     {
         RegisterRootObject(InputManager);
Index: /code/branches/gui/src/core/input/InputManager.h
===================================================================
--- /code/branches/gui/src/core/input/InputManager.h	(revision 1644)
+++ /code/branches/gui/src/core/input/InputManager.h	(revision 1645)
@@ -85,7 +85,7 @@
     {
         // --> setConfigValues is private
-        friend ClassIdentifier<InputManager>;
+        friend class ClassIdentifier<InputManager>;
         // let Core class use tick(.)
-        friend Core;
+        friend class Core;
 
     public:
Index: /code/branches/gui/src/orxonox/CMakeLists.txt
===================================================================
--- /code/branches/gui/src/orxonox/CMakeLists.txt	(revision 1644)
+++ /code/branches/gui/src/orxonox/CMakeLists.txt	(revision 1645)
@@ -59,5 +59,5 @@
 ADD_CUSTOM_COMMAND(
   OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/tolua/tolua_bind.cc
-  COMMAND ${TOLUA_EXE} -n orxonox -o ../../src/orxonox/tolua/tolua_bind.cc -H ../../src/orxonox/tolua/tolua_bind.h ../../src/orxonox/tolua/tolua.pkg
+  COMMAND ${TOLUA_EXE} -n Orxonox -o ../../src/orxonox/tolua/tolua_bind.cc -H ../../src/orxonox/tolua/tolua_bind.h ../../src/orxonox/tolua/tolua.pkg
   DEPENDS tolua
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/bin/lib
@@ -89,4 +89,5 @@
   ${Lua_LIBRARIES}
   ${CEGUI_LIBRARIES}
+  ${CEGUI_SCRIPT_LIBRARIES}
   tinyxml
   tolualib
Index: /code/branches/gui/src/orxonox/Orxonox.cc
===================================================================
--- /code/branches/gui/src/orxonox/Orxonox.cc	(revision 1644)
+++ /code/branches/gui/src/orxonox/Orxonox.cc	(revision 1645)
@@ -468,6 +468,5 @@
     unsigned long frameCount = 0;
     
-    const unsigned long refreshTime = 50000.0f;
-    //const unsigned long refreshTime = debugRefreshTime_ * 1000000.0f;
+    const unsigned long refreshTime = (unsigned long)(debugRefreshTime_ * 1000000.0f);
     unsigned long refreshStartTime = 0;
     unsigned long tickTime = 0;
Index: /code/branches/gui/src/orxonox/gui/GUIManager.cc
===================================================================
--- /code/branches/gui/src/orxonox/gui/GUIManager.cc	(revision 1644)
+++ /code/branches/gui/src/orxonox/gui/GUIManager.cc	(revision 1645)
@@ -126,6 +126,10 @@
             catch (CEGUI::Exception& ex)
             {
+#if CEGUI_VERSION_MINOR < 6
+                throw GeneralException(ex.getMessage().c_str());
+#else
                 throw GeneralException(ex.getMessage().c_str(), ex.getLine(),
                     ex.getFileName().c_str(), ex.getName().c_str());
+#endif
             }
 
@@ -166,6 +170,10 @@
         catch (CEGUI::Exception& ex)
         {
+#if CEGUI_VERSION_MINOR < 6
+            throw GeneralException(ex.getMessage().c_str());
+#else
             throw GeneralException(ex.getMessage().c_str(), ex.getLine(),
                 ex.getFileName().c_str(), ex.getName().c_str());
+#endif
         }
     }