Index: code/branches/gui/src/core/Script.h
===================================================================
--- code/branches/gui/src/core/Script.h	(revision 1646)
+++ code/branches/gui/src/core/Script.h	(revision 1647)
@@ -28,5 +28,5 @@
 
 /**
- @file  script.h
+ @file
  @brief Representation of an interface to lua
  @author Benjamin Knecht <beni_at_orxonox.net>
@@ -47,7 +47,9 @@
 namespace orxonox // tolua_export
 { // tolua_export
-
-  class _CoreExport Script // tolua_export
-  { // tolua_export
+  class _CoreExport Script
+  /*
+  class Script { // tolua_export
+  */
+  {
     struct LoadS {
       const char *s;
Index: code/branches/gui/src/core/Script_clean.h
===================================================================
--- code/branches/gui/src/core/Script_clean.h	(revision 1646)
+++ 	(revision )
@@ -1,83 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Benjamin Knecht
- *   Co-authors:
- *      ...
- *
- */
-
-/**
- @file  script.h
- @brief Representation of an interface to lua
- @author Benjamin Knecht <beni_at_orxonox.net>
- */
-
-#ifndef _Script_H__
-#define _Script_H__
-
-#include "CorePrereqs.h"
-
-extern "C" {
-#include <lua.h>
-}
-
-#include <list>
-#include <string>
-
-namespace orxonox // tolua_export
-{ // tolua_export
-
-  class  Script // tolua_export
-  { // tolua_export
-    public:
-      inline static Script* getInstance() { if (!Script::singletonRef) Script::singletonRef = new Script(); return Script::singletonRef; } // tolua_export
-      inline ~Script() { Script::singletonRef = NULL; };
-
-    void loadFile(std::string filename, bool luaTags);
-    //void init(lua_State *state_);
-    //void xmlToLua();
-    void run();
-    void luaPrint(std::string str); // tolua_export
-
-#if LUA_VERSION_NUM != 501
-    inline static const char * lua_Chunkreader(lua_State *L, void *data, size_t *size) { return NULL;};
-#endif
-
-    inline lua_State* getLuaState() { return luaState_; };
-    inline std::string getLuaOutput() { return output_; };
-    //inline std::string* getFileString() { return &fileString_; };
-
-    unsigned int getNextQuote(const std::string& text, unsigned int start);
-    std::string replaceLuaTags(const std::string& text);
-
-    private:
-      Script();
-      static Script* singletonRef;
-
-      std::string luaSource_;
-      std::string output_;
-      lua_State* luaState_;
-
-  }; // tolua_export
-} // tolua_export
-#endif /* _Script_H__ */
Index: code/branches/gui/src/core/tolua/tolua.pkg
===================================================================
--- code/branches/gui/src/core/tolua/tolua.pkg	(revision 1646)
+++ code/branches/gui/src/core/tolua/tolua.pkg	(revision 1647)
@@ -1,2 +1,2 @@
-$cfile "../../src/core/Script_clean.h"
+$cfile "../../src/core/Script.h"
 $cfile "../../src/core/CommandExecutor.h"
Index: code/branches/gui/src/orxonox/gui/GUIManager.h
===================================================================
--- code/branches/gui/src/orxonox/gui/GUIManager.h	(revision 1646)
+++ code/branches/gui/src/orxonox/gui/GUIManager.h	(revision 1647)
@@ -73,5 +73,9 @@
 
         bool initialise();
-        void tick(float dt);
+        void tick(float dt)
+        {
+            assert(guiSystem_);
+            guiSystem_->injectTimePulse(dt);
+        }
         void showGUI(const std::string& name, Ogre::SceneManager* sceneManager);// bool showBackground); // tolua_export
         void _hideGUI(); // tolua_export
@@ -131,10 +135,4 @@
         static GUIManager*        singletonRef_s;
     }; // tolua_export
-
-    inline void GUIManager::tick(float dt)
-    {
-        assert(guiSystem_);
-        guiSystem_->injectTimePulse(dt);
-    }
 } // tolua_export
 