Index: code/branches/core3/src/core/ConfigFileManager.cc
===================================================================
--- code/branches/core3/src/core/ConfigFileManager.cc	(revision 1655)
+++ code/branches/core3/src/core/ConfigFileManager.cc	(revision 1658)
@@ -71,20 +71,20 @@
     void reloadConfig()
     {
-        ConfigFileManager::getSingleton()->load();
+        ConfigFileManager::getInstance()->load();
     }
 
     void cleanConfig()
     {
-        ConfigFileManager::getSingleton()->clean(false);
+        ConfigFileManager::getInstance()->clean(false);
     }
 
     void loadSettings(const std::string& filename)
     {
-        ConfigFileManager::getSingleton()->setFile(CFT_Settings, filename, false);
+        ConfigFileManager::getInstance()->setFile(CFT_Settings, filename, false);
     }
 
     void loadKeybindings(const std::string& filename)
     {
-        ConfigFileManager::getSingleton()->setFile(CFT_Keybindings, filename);
+        ConfigFileManager::getInstance()->setFile(CFT_Keybindings, filename);
     }
 
@@ -459,5 +459,5 @@
     }
 
-    ConfigFileManager* ConfigFileManager::getSingleton()
+    ConfigFileManager* ConfigFileManager::getInstance()
     {
         static ConfigFileManager instance;
Index: code/branches/core3/src/core/ConfigFileManager.h
===================================================================
--- code/branches/core3/src/core/ConfigFileManager.h	(revision 1655)
+++ code/branches/core3/src/core/ConfigFileManager.h	(revision 1658)
@@ -258,5 +258,5 @@
     {
         public:
-            static ConfigFileManager* getSingleton();
+            static ConfigFileManager* getInstance();
 
             void setFile(ConfigFileType type, const std::string& filename, bool bCreateIfNotExisting = true);
Index: code/branches/core3/src/core/ConfigValueContainer.cc
===================================================================
--- code/branches/core3/src/core/ConfigValueContainer.cc	(revision 1655)
+++ code/branches/core3/src/core/ConfigValueContainer.cc	(revision 1658)
@@ -82,5 +82,5 @@
         for (unsigned int i = 0; i < this->valueVector_.size(); i++)
         {
-            ConfigFileManager::getSingleton()->getValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i].toString(), this->value_.isA(MT_string));
+            ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i].toString(), this->value_.isA(MT_string));
             this->defvalueStringVector_.push_back(this->valueVector_[i].toString());
         }
@@ -113,5 +113,5 @@
             if (this->tset(input))
             {
-                ConfigFileManager::getSingleton()->setValue(this->type_, this->sectionname_, this->varname_, input.toString(), this->value_.isA(MT_string));
+                ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, input.toString(), this->value_.isA(MT_string));
                 return true;
             }
@@ -132,5 +132,5 @@
             if (this->tset(index, input))
             {
-                ConfigFileManager::getSingleton()->setValue(this->type_, this->sectionname_, this->varname_, index, input.toString(), this->value_.isA(MT_string));
+                ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, index, input.toString(), this->value_.isA(MT_string));
                 return true;
             }
@@ -239,6 +239,6 @@
                 this->valueVector_.erase(this->valueVector_.begin() + index);
                 for (unsigned int i = index; i < this->valueVector_.size(); i++)
-                    ConfigFileManager::getSingleton()->setValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isA(MT_string));
-                ConfigFileManager::getSingleton()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->valueVector_.size());
+                    ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isA(MT_string));
+                ConfigFileManager::getInstance()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->valueVector_.size());
 
                 return true;
@@ -264,5 +264,5 @@
                 if (!this->set(i, this->defvalueStringVector_[i]))
                     success = false;
-            ConfigFileManager::getSingleton()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->defvalueStringVector_.size());
+            ConfigFileManager::getInstance()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->defvalueStringVector_.size());
             return success;
         }
@@ -275,17 +275,17 @@
     {
         if (!this->bIsVector_)
-            this->value_.fromString(ConfigFileManager::getSingleton()->getValue(this->type_, this->sectionname_, this->varname_, this->defvalueString_, this->value_.isA(MT_string)));
+            this->value_.fromString(ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, this->defvalueString_, this->value_.isA(MT_string)));
         else
         {
             this->valueVector_.clear();
-            for (unsigned int i = 0; i < ConfigFileManager::getSingleton()->getVectorSize(this->type_, this->sectionname_, this->varname_); i++)
+            for (unsigned int i = 0; i < ConfigFileManager::getInstance()->getVectorSize(this->type_, this->sectionname_, this->varname_); i++)
             {
                 if (i < this->defvalueStringVector_.size())
                 {
-                    this->value_.fromString(ConfigFileManager::getSingleton()->getValue(this->type_, this->sectionname_, this->varname_, i, this->defvalueStringVector_[i], this->value_.isA(MT_string)));
+                    this->value_.fromString(ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, this->defvalueStringVector_[i], this->value_.isA(MT_string)));
                 }
                 else
                 {
-                    this->value_.fromString(ConfigFileManager::getSingleton()->getValue(this->type_, this->sectionname_, this->varname_, i, MultiTypeMath(), this->value_.isA(MT_string)));
+                    this->value_.fromString(ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, MultiTypeMath(), this->value_.isA(MT_string)));
                 }
 
Index: code/branches/core3/src/core/input/KeyBinder.cc
===================================================================
--- code/branches/core3/src/core/input/KeyBinder.cc	(revision 1655)
+++ code/branches/core3/src/core/input/KeyBinder.cc	(revision 1658)
@@ -216,10 +216,10 @@
     if (!infile)
     {
-      ConfigFileManager::getSingleton()->setFile(CFT_Keybindings, "def_keybindings.ini");
-      ConfigFileManager::getSingleton()->save(CFT_Keybindings, "keybindings.ini");
+      ConfigFileManager::getInstance()->setFile(CFT_Keybindings, "def_keybindings.ini");
+      ConfigFileManager::getInstance()->save(CFT_Keybindings, "keybindings.ini");
     }
     else
       infile.close();
-    ConfigFileManager::getSingleton()->setFile(CFT_Keybindings, "keybindings.ini");
+    ConfigFileManager::getInstance()->setFile(CFT_Keybindings, "keybindings.ini");
 
     // parse key bindings
Index: code/branches/core3/src/orxonox/Orxonox.cc
===================================================================
--- code/branches/core3/src/orxonox/Orxonox.cc	(revision 1655)
+++ code/branches/core3/src/orxonox/Orxonox.cc	(revision 1658)
@@ -184,7 +184,7 @@
   {
 #ifdef _DEBUG
-    ConfigFileManager::getSingleton()->setFile(CFT_Settings, "orxonox_d.ini");
+    ConfigFileManager::getInstance()->setFile(CFT_Settings, "orxonox_d.ini");
 #else
-    ConfigFileManager::getSingleton()->setFile(CFT_Settings, "orxonox.ini");
+    ConfigFileManager::getInstance()->setFile(CFT_Settings, "orxonox.ini");
 #endif
     Factory::createClassHierarchy();